var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
import React, { useMemo, useEffect, useState } from 'react';
import { ChildBlockRenderer, useSettingTemplate } from '@compoz/ui';
var ApiCallBlockRenderer = function (_a) {
    var block = _a.block, pageContext = _a.pageContext, parentContext = _a.parentContext;
    var url = useSettingTemplate(block.settings.enableTemplating, block.settings.url, parentContext);
    var _b = useState({
        isFetching: true,
        error: null,
        data: {}
    }), apiResponse = _b[0], setApiResponse = _b[1];
    var callData = useEffect(function () {
        fetch(url, {
            method: block.settings.method,
        })
            .then(function (res) { return res.json(); })
            .then(function (data) {
            setApiResponse({
                isFetching: false,
                error: null,
                data: data
            });
        });
        return function () { };
    }, [url, block.settings]);
    var newParentContext = useMemo(function () {
        var _a;
        return __assign({}, parentContext, (_a = {}, _a[block.settings.contextKey] = apiResponse.data, _a));
    }, [parentContext, block.settings.contextKey, apiResponse.data]);
    console.log(newParentContext);
    return (React.createElement(React.Fragment, null,
        apiResponse.isFetching && React.createElement("div", null, "\u2026fetching\u2026"),
        !apiResponse.isFetching && block.children.map(function (id) { return (React.createElement(ChildBlockRenderer, { key: id, id: id, parent: block, pageContext: pageContext, parentContext: newParentContext })); })));
};
export default ApiCallBlockRenderer;
